#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum NumericOutputField {
    #[serde(rename = "MIN")]
    Min,
    #[serde(rename = "MAX")]
    Max,
    #[serde(rename = "MEAN")]
    Mean,
    #[serde(rename = "COUNT")]
    Count,
    #[serde(rename = "VARIANCE")]
    Variance,
    #[serde(rename = "FIRST_POINT")]
    FirstPoint,
    #[serde(rename = "LAST_POINT")]
    LastPoint,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl NumericOutputField {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            NumericOutputField::Min => "MIN",
            NumericOutputField::Max => "MAX",
            NumericOutputField::Mean => "MEAN",
            NumericOutputField::Count => "COUNT",
            NumericOutputField::Variance => "VARIANCE",
            NumericOutputField::FirstPoint => "FIRST_POINT",
            NumericOutputField::LastPoint => "LAST_POINT",
            NumericOutputField::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for NumericOutputField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for NumericOutputField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for NumericOutputField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<NumericOutputField, conjure_object::plain::ParseEnumError> {
        match v {
            "MIN" => Ok(NumericOutputField::Min),
            "MAX" => Ok(NumericOutputField::Max),
            "MEAN" => Ok(NumericOutputField::Mean),
            "COUNT" => Ok(NumericOutputField::Count),
            "VARIANCE" => Ok(NumericOutputField::Variance),
            "FIRST_POINT" => Ok(NumericOutputField::FirstPoint),
            "LAST_POINT" => Ok(NumericOutputField::LastPoint),
            v => v.parse().map(|v| NumericOutputField::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for NumericOutputField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<NumericOutputField, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the NumericOutputField enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
